package com.bs.pje.model.blogic.common;

import java.util.HashMap;
import java.util.Map;

import javax.annotation.security.RolesAllowed;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;

// @Singleton
@Stateless
@RolesAllowed( {"BSUSER", "BSADMIN" })
public class BSUnique {

  private final Map<String, BSUserInfo> mUInfo =
    new HashMap<String, BSUserInfo>();

  //  @Lock(LockType.WRITE)
  public void putInfo(final String user, final BSUserInfo info) {
    System.out.println("putInfo(" + user + ", " + info + ")");
    if (info == null)
      mUInfo.remove(user);
    else
      mUInfo.put(user, info);
  }

  //  @Lock(LockType.READ)
  public BSUserInfo getInfo(final String user) {
    return mUInfo.get(user);
  }

  //  @Lock(LockType.READ)
  public BSUserInfo getInfo(final SessionContext sc) {
    return mUInfo.get(sc.getCallerPrincipal().getName());
  }

}
